#!/usr/bin/env python


from wxPython.wx import *
from wxAppXmlParser import *
import string

    
test_menu = """
<?xml version="1.0"?>
<wxappdef title="Calendar" wide="400" high="600" statusbar="default">
  <menudef>
    <menu name="&File">
       <menuitem name="&Open" accel="Ctrl-O" id="1001" tip="Open this up" />
       <menuitem name="&New" accel="Ctrl-N" id="1002" tip="Open this up" />
       <menuitem name="&Save" accel="Ctrl-S" id="1003" tip="Open this up" />
       <menuitem name="Save &As..." accel="Ctrl-A" id="1004" tip="Open this up" />
       <menuseparator />
       <menuitem name="E&xit" accel="Ctrl-X" id="1005" />
    </menu>
    <menu name="&Edit">
       <menuitem name="Copy" accel="Alt-C" id="2001" />
       <menuitem name="Cut" accel="Alt-X"  id="2002"/>
       <menuitem name="Paste" accel="Alt-V" id="2003" />
    </menu>
  </menudef>
  <toolbar>
    <toolbaritem name="Open" bitmap="Open" id="1001" tip="Open this up" />
    <toolbaritem name="New" bitmap="Open" id="1002" tip="Open this up" />
    <toolbaritem name="Save" bitmap="Open" id="1003" tip="Open this up" />
    <toolbaritem name="Save As" bitmap="Open" id="1004" tip="Open this up" />
    <toolbarseparator />
    <toolbaritem name="Copy" bitmap="Copy" id="2001" />
    <toolbaritem name="Cut" bitmap="Cut" id="2002"/>
    <toolbaritem name="Paste" bitmap="Paste" id="2003" />
  </toolbar>
</wxappdef>
"""

    
# ========================================================================
class App(wxFrame):
    def __init__( self, res ):
	wxFrame.__init__( self, NULL, -1, '', wxDefaultPosition, wxDefaultSize)
	self.ids = {}
	self.menubar = None
	self.toolbar = None
	self.parseResources( res )
	
    # --------------------------------------------------------------------
    def parseResources( self, data ):
	xml = wxAppXmlMenuParser(self)
	xml.feed( data )
	xml.close()
		
    # --------------------------------------------------------------------
    def OnExit( self, event ):
	self.Close(true)
	
    # --------------------------------------------------------------------
    def OnNotAvailable( self, event ):
	dlg = wxMessageDialog( self, 'Operation not available', 'Sorry',
                               wxOK | wxICON_ERROR )
	dlg.ShowModal()
	dlg.Destroy()
	

    # --------------------------------------------------------------------
    def getIdForCommand( self, cmd ):
	for id in self.ids.keys():
	    if cmd == self.cleanCommand( self.ids[id] ):
		return id
	return -1
	
    # --------------------------------------------------------------------
    def EnableCmd( self, cmd ):
	if type(cmd) == type([]):
	    for c in cmd:
		self._EnableCmd( c )
	else:
	    self._EnableCmd( cmd )
	    
    # --------------------------------------------------------------------
    def DisableCmd( self, cmd ):
	if type(cmd) == type([]):
	    for c in cmd:
		self._DisableCmd( c )
	else:
	    self._DisableCmd( cmd )
    
    # --------------------------------------------------------------------
    def _EnableCmd( self, cmd ):
	id = self.getIdForCommand( cmd )
	if id == -1:
	    return
	if self.menubar:
	    mi = self.menubar.FindItemById( id )
	    mi.Enable( true )
	if self.toolbar:
	    self.toolbar.EnableTool( id, true )
	    
    # --------------------------------------------------------------------
    def _DisableCmd( self, cmd ):
	id = self.getIdForCommand( cmd )
	if id == -1:
	    return
	if self.menubar:
	    mi = self.menubar.FindItemById( id )
	    mi.Enable( false )
	if self.toolbar:
	    self.toolbar.EnableTool( id, false )
	

    # --------------------------------------------------------------------
    # cleans a command to all ASCII
    def cleanCommand( self, cmd ):
	s = string.replace( cmd, ' ', '' )
	s = string.replace( s, '&', '' )
	s = string.replace( s, '.', '' )
	return s
    
# ========================================================================
class mApp( wxApp ):
    def OnInit( self ):
	frame = App( NULL, -1, 'App', test_menu )
	frame.Show(true)
	self.SetTopWindow(frame)
	return true

def main():
    app = mApp(0)
    app.MainLoop()
    
# ========================================================================
# ------------------------------------------------------------------------
if __name__ == '__main__':
    main()
